<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Setter - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Image.html">Image</a><ul class='members'><li data-type='member' style='display: none;'><a href="Image.html#channels">channels</a></li><li data-type='member' style='display: none;'><a href="Image.html#parameters">parameters</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Image.html#set">set</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-Setter.html">Setter</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-Setter.html#set">set</a></li><li data-type='method' style='display: none;'><a href="aidecv-Setter.html#.getSetters">getSetters</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-Similarity.html">Similarity</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-Similarity.html#set">set</a></li><li data-type='method' style='display: none;'><a href="aidecv-Similarity.html#.getSimilarities">getSimilarities</a></li></ul></li><li><a href="commands.html">commands</a><ul class='members'></ul></li><li><a href="aidecv.html">aidecv</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2mat">mat2mat</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2json">mat2json</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.mat2txt">mat2txt</a></li><li data-type='method' style='display: none;'><a href="aidecv.html#.bgr2bin">bgr2bin</a></li></ul></li><li style="padding-left:20px;border-left:1px solid lightgray;margin-top:-10px" ><a href="aidecv-opencvwindow.html">opencvwindow</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="aidecv-opencvwindow.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="aidecv-opencvwindow.html#.waitUntilWindowsClosed">waitUntilWindowsClosed</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Setter</h1>
    

    




<section>

<header>
    
        <h2>
            <span class="ancestors"><a href="aidecv.html">aidecv</a>~</span>
        
        
            Setter
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="Setter"><span class="type-signature"></span>new Setter<span class="signature">(name)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Template to implement a setter hook mechanism.
A typical implementation is of the form:</p>
<pre class="prettyprint source"><code>#include &quot;Setter.hpp&quot;
namespace aidecv {
  class SomethingSetter : public Setter {
  public:
    SomethingSetter() : Setter(&quot;something&quot;){}
    void set(Image& target, JSON command, const Image& source_if_any) {
      // Implements the setter
    }
  } somethingSetter;
}
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The 'do' operation name to register for this setter.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="set"><span class="type-signature"></span>set<span class="signature">(target, command, source)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the setter operation.</p>
<ul>
<li>Typically modifies the target given the command, optionnaly using the source.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>target</code></td>
            

            <td class="type">
            
                
<span class="param-type">Mat</span>



            
            </td>

            

            

            <td class="description last"><p>The input/output image.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>command</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>The command parameters.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>source</code></td>
            

            <td class="type">
            
                
<span class="param-type">Mat</span>



            
            </td>

            

            

            <td class="description last"><p>The source image if any, otherwise an empty image.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".getSetters"><span class="type-signature type-signature-static">(static) </span>getSetters<span class="signature">()</span><span class="type-signature"> &rarr; {Map}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the setters table</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A <code>std::map &lt; std::string, Setter * &gt;</code> with the register setters indexed by the 'do' operation name.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Map</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>